package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.file.*;
import com.tmax.openframe.command.*;
import com.tmax.openframe.tsq.TSQ;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPBROS_InputDto;
import com.tmax.openframe.dto.OIVPBROS_OutputDto;
import com.tmax.openframe.variable.OIVPBROS_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPBROS implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPBROS_VariableContainer container = new OIVPBROS_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0300_GO_MAIN = this::_0300_GO_MAIN;
    Runnable _0400_READ_NEXT_LIST = this::_0400_READ_NEXT_LIST;
    Runnable _0450_READ_NEXT = this::_0450_READ_NEXT;
    Runnable _0500_READ_PREV_LIST = this::_0500_READ_PREV_LIST;
    Runnable _0550_READ_PREV = this::_0550_READ_PREV;
    Runnable _0600_GO_FORWARD = this::_0600_GO_FORWARD;
    Runnable _0700_GO_BACKWARD = this::_0700_GO_BACKWARD;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_INFO = this::_5200_INFO;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7100_RECEIVEMAP = this::_7100_RECEIVEMAP;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0300_GO_MAIN);
        MethodFlow.add(_0400_READ_NEXT_LIST);
        MethodFlow.add(_0450_READ_NEXT);
        MethodFlow.add(_0500_READ_PREV_LIST);
        MethodFlow.add(_0550_READ_PREV);
        MethodFlow.add(_0600_GO_FORWARD);
        MethodFlow.add(_0700_GO_BACKWARD);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_INFO);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7100_RECEIVEMAP);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPBROS_InputDto inputDto;
    @Getter
    @Setter
    OIVPBROS_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPBROS() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPBROS_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPBROS_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF1_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0300_GO_MAIN);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPBROS_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF2_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0700_GO_BACKWARD);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPBROS_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF3_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0600_GO_FORWARD);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM02I(OIVPBROS_OIVPM02I.createDefaultValueInstance());
        container.setMSGO("DATA FOUND");
        run(_5200_INFO);
        if (GoTo != null || Return) {
            return;
        }
        run(_0400_READ_NEXT_LIST);
        if (GoTo != null || Return) {
            return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0300_GO_MAIN() throws CicsException {
        // ("EXEC CICS START TRANSID('OIVP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIVP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPMAIN_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0400_READ_NEXT_LIST() throws CicsException {
        // ("EXEC CICS STARTBR FILE(FILE01) RIDFLD(START-KEY) KEYLENGTH(LEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartbrOption option = StartbrOption.builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getSTART_KEY()))
                    .keylength((int) container.getLEN()).build();
            File.startbr(option, OIVPDS_DOF.class);
            container.setSTART_KEY(Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        container.setKEY01(container.getSTART_KEY());
        run(_0450_READ_NEXT);
        if (GoTo != null || Return) {
            return;
        }
        container.setBIDXO(String.valueOf(container.getKEY01()));
        container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
        container.setIDEN1O(String.valueOf(container.getKEY01()));
        container.setNAME1O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT1O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON1O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0450_READ_NEXT);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN2O(String.valueOf(container.getKEY01()));
        container.setNAME2O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT2O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON2O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0450_READ_NEXT);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN3O(String.valueOf(container.getKEY01()));
        container.setNAME3O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT3O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON3O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0450_READ_NEXT);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN4O(String.valueOf(container.getKEY01()));
        container.setNAME4O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT4O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON4O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0450_READ_NEXT);
        if (GoTo != null || Return) {
            return;
        }
        container.setFIDXO(String.valueOf(container.getKEY01()));
        container.getOIVPM02I().setFIDXA(container.getPROT_DARK_MDT());
        container.setIDEN5O(String.valueOf(container.getKEY01()));
        container.setNAME5O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT5O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON5O(container.getPEOPLE_INFO().getWS_PHONE());
        container.setMSGO("DATA FOUND");
        // ("EXEC CICS ENDBR FILE(FILE01) END-EXEC");
        try {
            EndbrOption option = EndbrOption.builder()
                    .file(container.getFILE01()).build();
            File.endbr(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _0450_READ_NEXT() throws CicsException {
        // ("EXEC CICS READNEXT FILE(FILE01) INTO(PEOPLE-INFO) RIDFLD(KEY01) KEYLENGTH(LEN) LENGTH(DATALEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            ReadnextOption option = ReadnextOption
                    .builder()
                    .file(container.getFILE01())
                    .into(OIVPBROS_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .ridfld(String.valueOf(container.getKEY01()))
                    .keylength((int) container.getLEN())
                    .length((int) container.getDATALEN()).build();
            File.readnext(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO(OIVPBROS_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.setKEY01(Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.ENDFILE
                .getResponseCode()) {
            container.setMSGO("NO MORE DATA");
            container.getOIVPM02I().setFIDXA(container.getPROT_DARK_MDT());
            container.setPEOPLE_INFO(OIVPBROS_PEOPLE_INFO
                    .createDefaultValueInstance());
            run(_7200_SENDMAP);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            container.setMSGO("NO MORE DATA");
            container.getOIVPM02I().setFIDXA(container.getPROT_DARK_MDT());
            container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
            container.setPEOPLE_INFO(OIVPBROS_PEOPLE_INFO
                    .createDefaultValueInstance());
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _0500_READ_PREV_LIST() throws CicsException {
        container.setTEMP_KEY(container.getSTART_KEY());
        do {
            if (container.getTEMP_KEY() == 0) {
                container.setMSGO("NO MORE DATA");
                container.getOIVPM02I().setFIDXA(container.getPROT_DARK_MDT());
                container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
                run(_7250_SENDMAP_DATA);
                if (GoTo != null || Return) {
                    return;
                }
                run(_5300_RETURN_TRANS_ID);
                if (GoTo != null || Return) {
                    return;
                }
            }
            container.setSTART_KEY(container.getTEMP_KEY());
            // ("EXEC CICS STARTBR FILE(FILE01) RIDFLD(START-KEY) KEYLENGTH(LEN) RESP(WS-RESPONSE-CODE) END-EXEC");
            try {
                StartbrOption option = StartbrOption.builder()
                        .file(container.getFILE01())
                        .ridfld(String.valueOf(container.getSTART_KEY()))
                        .keylength((int) container.getLEN()).build();
                File.startbr(option, OIVPDS_DOF.class);
                container.setSTART_KEY(Integer.parseInt(option.getRidfld()));
            } catch (CicsConditionException e) {
            } catch (RuntimeException e) {
                GoTo = systemData.getErrorRunnable(e);
            } finally {
                container.setWS_RESPONSE_CODE(eib.getEibResp());
                if (GoTo != null)
                    return;
            }
            if (container.getSTART_KEY() != container.getTEMP_KEY()) {
                container.setTEMP_KEY(container.getTEMP_KEY() + -1);
            }
            // ("EXEC CICS ENDBR FILE(FILE01) END-EXEC");
            try {
                EndbrOption option = EndbrOption.builder()
                        .file(container.getFILE01()).build();
                File.endbr(option);
            } catch (CicsConditionException e) {
                GoTo = systemData.getConditionRunnable(e);
            } catch (RuntimeException e) {
                GoTo = systemData.getErrorRunnable(e);
            } finally {
                if (GoTo != null)
                    return;
            }
        } while (!(container.getSTART_KEY() == container.getTEMP_KEY()));
        // ("EXEC CICS STARTBR FILE(FILE01) RIDFLD(START-KEY) KEYLENGTH(LEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartbrOption option = StartbrOption.builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getSTART_KEY()))
                    .keylength((int) container.getLEN()).build();
            File.startbr(option, OIVPDS_DOF.class);
            container.setSTART_KEY(Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        container.setKEY01(container.getSTART_KEY());
        run(_0550_READ_PREV);
        if (GoTo != null || Return) {
            return;
        }
        container.setFIDXO(String.valueOf(container.getKEY01()));
        container.getOIVPM02I().setFIDXA(container.getPROT_DARK_MDT());
        container.setIDEN5O(String.valueOf(container.getKEY01()));
        container.setNAME5O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT5O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON5O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0550_READ_PREV);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN4O(String.valueOf(container.getKEY01()));
        container.setNAME4O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT4O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON4O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0550_READ_PREV);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN3O(String.valueOf(container.getKEY01()));
        container.setNAME3O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT3O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON3O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0550_READ_PREV);
        if (GoTo != null || Return) {
            return;
        }
        container.setIDEN2O(String.valueOf(container.getKEY01()));
        container.setNAME2O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT2O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON2O(container.getPEOPLE_INFO().getWS_PHONE());
        run(_0550_READ_PREV);
        if (GoTo != null || Return) {
            return;
        }
        container.setBIDXO(String.valueOf(container.getKEY01()));
        container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
        container.setIDEN1O(String.valueOf(container.getKEY01()));
        container.setNAME1O(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPT1O(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHON1O(container.getPEOPLE_INFO().getWS_PHONE());
        container.setMSGO("DATA FOUND");
        // ("EXEC CICS ENDBR FILE(FILE01) END-EXEC");
        try {
            EndbrOption option = EndbrOption.builder()
                    .file(container.getFILE01()).build();
            File.endbr(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _0550_READ_PREV() throws CicsException {
        // ("EXEC CICS READPREV FILE(FILE01) INTO(PEOPLE-INFO) RIDFLD(KEY01) KEYLENGTH(LEN) LENGTH(DATALEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            ReadprevOption option = ReadprevOption
                    .builder()
                    .file(container.getFILE01())
                    .into(OIVPBROS_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .ridfld(String.valueOf(container.getKEY01()))
                    .keylength((int) container.getLEN())
                    .length((int) container.getDATALEN()).build();
            File.readprev(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO(OIVPBROS_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.setKEY01(Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
    }

    void _0600_GO_FORWARD() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        container.setBIDXO(container.getOIVPM02I().getFIDXI());
        container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
        container.setSTART_KEY(Integer.parseInt(container.getOIVPM02I()
                .getFIDXI()));
        container.setSTART_KEY(container.getSTART_KEY() + 1);
        run(_0400_READ_NEXT_LIST);
        if (GoTo != null || Return) {
            return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0700_GO_BACKWARD() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        container.setSTART_KEY(Integer.parseInt(container.getOIVPM02I()
                .getBIDXI()));
        container.getOIVPM02I().setBIDXA(container.getPROT_DARK_MDT());
        container.setSTART_KEY(container.getSTART_KEY() + -1);
        run(_0500_READ_PREV_LIST);
        if (GoTo != null || Return) {
            return;
        }
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPBROS_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_INFO() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPBROS_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPBROS_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPBROS_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
        System.out.println("WRITEQ TS QUEUE(MAIN)");
        container.setWSWRITEQ("WRITEQ");
        // ("EXEC CICS WRITEQ TS QUEUE('MAIN') FROM(WSWRITEQ) MAIN END-EXEC");
        try {
            WriteqTSOption option = WriteqTSOption.builder().queue("MAIN")
                    .from(container.getWSWRITEQ()).build();
            TSQ.write(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        System.out.println("READQ TS QUEUE(MAIN)");
        // ("EXEC CICS READQ TS QUEUE('MAIN') INTO(WSREADQ) END-EXEC");
        try {
            ReadqTSOption option = ReadqTSOption.builder().queue("MAIN")
                    .into(container.getWSREADQ()).build();
            TSQ.read(option);
            container.setWSREADQ((String) option.getInto());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID ('OIBR') COMMAREA (WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPBROS_DFHCOMMAREADto dfhcommareaDto = new OIVPBROS_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIBR")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPBROS_DFHCOMMAREADto dfhcommareaDto = new OIVPBROS_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7100_RECEIVEMAP() throws CicsException {
        // ("EXEC CICS RECEIVE MAP('OIVPM02') MAPSET('OIVPM02') INTO(OIVPM02I) END-EXEC");
        try {
            ReceiveMapOption option = ReceiveMapOption.builder().build();
            OIVPM02_OIVPM02_dataToOIVPBROS_OIVPM02IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM02_OIVPM02_data(),
                            container.getOIVPM02I());
            OIVPM02_OIVPM02_metaToOIVPBROS_OIVPM02IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM02_OIVPM02_meta(),
                            container.getOIVPM02I());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM02') MAPSET('OIVPM02') FROM(OIVPM02O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPBROS_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM02");
            outputDto.getScreenDto().setMapSetName("OIVPM02");
            try {
                OIVPM02_OIVPM02_data oivpm02_oivpm02_data = new OIVPM02_OIVPM02_data();
                OIVPM02_OIVPM02_meta oivpm02_oivpm02_meta = new OIVPM02_OIVPM02_meta();
                OIVPBROS_OIVPM02OToOIVPM02_OIVPM02_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM02O(), oivpm02_oivpm02_data);
                OIVPBROS_OIVPM02OToOIVPM02_OIVPM02_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM02O(), oivpm02_oivpm02_meta);
                outputDto.getScreenDto().setOIVPM02_OIVPM02_data(
                        oivpm02_oivpm02_data);
                outputDto.getScreenDto().setOIVPM02_OIVPM02_meta(
                        oivpm02_oivpm02_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM02') MAPSET('OIVPM02') FROM(OIVPM02O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPBROS_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM02");
            outputDto.getScreenDto().setMapSetName("OIVPM02");
            try {
                OIVPM02_OIVPM02_data oivpm02_oivpm02_data = new OIVPM02_OIVPM02_data();
                OIVPM02_OIVPM02_meta oivpm02_oivpm02_meta = new OIVPM02_OIVPM02_meta();
                OIVPBROS_OIVPM02OToOIVPM02_OIVPM02_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM02O(), oivpm02_oivpm02_data);
                OIVPBROS_OIVPM02OToOIVPM02_OIVPM02_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM02O(), oivpm02_oivpm02_meta);
                outputDto.getScreenDto().setOIVPM02_OIVPM02_data(
                        oivpm02_oivpm02_data);
                outputDto.getScreenDto().setOIVPM02_OIVPM02_meta(
                        oivpm02_oivpm02_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        container.setOIVPM02I(OIVPBROS_OIVPM02I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY ENTERD");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM('aaa') ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("aaa");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPBROS_DFHCOMMAREADto dfhcommareaDto = new OIVPBROS_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
